DeserializationConfig
Date: 2016-12-04

com.fasterxml.jackson.databind

## Class DeserializationConfig

- java.lang.Object
- - com.fasterxml.jackson.databind.cfg.MapperConfig<T>
  - - com.fasterxml.jackson.databind.cfg.MapperConfigBase<DeserializationFeature,DeserializationConfig>
    - - com.fasterxml.jackson.databind.DeserializationConfig

- All Implemented Interfaces:
    ClassIntrospector.MixInResolver, java.io.Serializable

      public final class DeserializationConfig
      extends MapperConfigBase<DeserializationFeature,DeserializationConfig>
      implements java.io.Serializable

  Object that contains baseline configuration for deserialization process. An instance is owned by `ObjectMapper`, which passes an immutable instance to be used for deserialization process.

  Note that instances are considered immutable and as such no copies should need to be created for sharing; all copying is done with "fluent factory" methods.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `_deserFeatures` Set of `DeserializationFeature`s enabled.
    `protected int` | `_formatReadFeatures` States of `FormatFeature`s to enable/disable.
    `protected int` | `_formatReadFeaturesToChange` Bitflag of `FormatFeature`s to enable/disable
    `protected JsonNodeFactory` | `_nodeFactory` Factory used for constructing `JsonNode` instances.
    `protected int` | `_parserFeatures` States of `JsonParser.Feature`s to enable/disable.
    `protected int` | `_parserFeaturesToChange` Bitflag of `JsonParser.Feature`s to enable/disable
    `protected LinkedNode<DeserializationProblemHandler>` | `_problemHandlers` Linked list that contains all registered problem handlers.

    - ### Fields inherited from class com.fasterxml.jackson.databind.cfg.MapperConfigBase

      `_attributes, _configOverrides, _mixIns, _rootName, _rootNames, _subtypeResolver, _view`

    - ### Fields inherited from class com.fasterxml.jackson.databind.cfg.MapperConfig

      `_base, _mapperFeatures, EMPTY_FORMAT, EMPTY_INCLUDE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `DeserializationConfig(BaseSettings base, SubtypeResolver str, SimpleMixInResolver mixins, RootNameLookup rootNames)` Deprecated. Since 2.8, remove from 2.9 or later
    `` | `DeserializationConfig(BaseSettings base, SubtypeResolver str, SimpleMixInResolver mixins, RootNameLookup rootNames, ConfigOverrides configOverrides)` Constructor used by ObjectMapper to create default configuration object instance.
    `protected` | `DeserializationConfig(DeserializationConfig src, ContextAttributes attrs)`
    `protected` | `DeserializationConfig(DeserializationConfig src, SimpleMixInResolver mixins)`
    `protected` | `DeserializationConfig(DeserializationConfig src, SimpleMixInResolver mixins, RootNameLookup rootNames, ConfigOverrides configOverrides)` Copy-constructor used for making a copy used by new `ObjectMapper`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `TypeDeserializer` | `findTypeDeserializer(JavaType baseType)` Helper method that is needed to properly handle polymorphic referenced types, such as types referenced by `AtomicReference`, or various "optional" types.
    `AnnotationIntrospector` | `getAnnotationIntrospector()` Method for getting `AnnotationIntrospector` configured to introspect annotation values used for configuration.
    `protected BaseSettings` | `getBaseSettings()`
    `com.fasterxml.jackson.annotation.JsonInclude.Value` | `getDefaultPropertyInclusion()` Accessor for default property inclusion to use for serialization, used unless overridden by per-type or per-property overrides.
    `com.fasterxml.jackson.annotation.JsonInclude.Value` | `getDefaultPropertyInclusion(java.lang.Class<?> baseType)` Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type. NOTE: if no override found, defaults to value returned by `MapperConfig.getDefaultPropertyInclusion()`.
    `com.fasterxml.jackson.annotation.JsonInclude.Value` | `getDefaultPropertyInclusion(java.lang.Class<?> baseType, com.fasterxml.jackson.annotation.JsonInclude.Value defaultIncl)` Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type; but if none found, returning given `defaultIncl`
    `int` | `getDeserializationFeatures()` Bulk access method for getting the bit mask of all `DeserializationFeature`s that are enabled.
    `JsonNodeFactory` | `getNodeFactory()`
    `LinkedNode<DeserializationProblemHandler>` | `getProblemHandlers()` Method for getting head of the problem handler chain.
    `boolean` | `hasDeserializationFeatures(int featureMask)` Bulk access method for checking that all features specified by mask are enabled.
    `boolean` | `hasSomeOfFeatures(int featureMask)` Bulk access method for checking that at least one of features specified by mask is enabled.
    `void` | `initialize(com.fasterxml.jackson.core.JsonParser p)` Method called by `ObjectMapper` and `ObjectReader` to modify those `JsonParser.Feature` settings that have been configured via this config instance.
    `<T extends BeanDescription> T` | `introspect(JavaType type)` Method that will introspect full bean properties for the purpose of building a bean deserializer
    `BeanDescription` | `introspectClassAnnotations(JavaType type)` Accessor for getting bean description that only contains class annotations: useful if no getter/setter/creator information is needed.
    `BeanDescription` | `introspectDirectClassAnnotations(JavaType type)` Accessor for getting bean description that only contains immediate class annotations: ones from the class, and its direct mix-in, if any, but not from super types.
    `<T extends BeanDescription> T` | `introspectForBuilder(JavaType type)`
    `<T extends BeanDescription> T` | `introspectForCreation(JavaType type)` Method that will introspect subset of bean properties needed to construct bean instance.
    `boolean` | `isEnabled(DeserializationFeature f)`
    `boolean` | `isEnabled(com.fasterxml.jackson.core.JsonParser.Feature f, com.fasterxml.jackson.core.JsonFactory factory)`
    `boolean` | `useRootWrapping()` Accessor for checking whether configuration indicates that "root wrapping" (use of an extra property/name pair at root level) is expected or not.
    `DeserializationConfig` | `with(AnnotationIntrospector ai)` Method for constructing and returning a new instance with different `AnnotationIntrospector` to use (replacing old one).
    `DeserializationConfig` | `with(com.fasterxml.jackson.core.Base64Variant base64)` Method for constructing and returning a new instance with different default `Base64Variant` to use with base64-encoded binary values.
    `DeserializationConfig` | `with(ClassIntrospector ci)` Method for constructing and returning a new instance with different `ClassIntrospector` to use.
    `DeserializationConfig` | `with(ContextAttributes attrs)` Method for constructing an instance that has specified contextual attributes.
    `DeserializationConfig` | `with(java.text.DateFormat df)` Method for constructing and returning a new instance with different `DateFormat` to use.
    `DeserializationConfig` | `with(DeserializationFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `DeserializationConfig` | `with(DeserializationFeature first, DeserializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `DeserializationConfig` | `with(com.fasterxml.jackson.core.FormatFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `DeserializationConfig` | `with(HandlerInstantiator hi)` Method for constructing and returning a new instance with different `HandlerInstantiator` to use.
    `DeserializationConfig` | `with(JsonNodeFactory f)` Fluent factory method that will construct a new instance with specified `JsonNodeFactory`
    `DeserializationConfig` | `with(com.fasterxml.jackson.core.JsonParser.Feature feature)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `DeserializationConfig` | `with(java.util.Locale l)` Method for constructing and returning a new instance with different default `Locale` to use for formatting.
    `DeserializationConfig` | `with(MapperFeature... features)` Method for constructing and returning a new instance with specified mapper features enabled.
    `DeserializationConfig` | `with(MapperFeature feature, boolean state)`
    `DeserializationConfig` | `with(PropertyNamingStrategy pns)` Method for constructing and returning a new instance with different `PropertyNamingStrategy` to use.
    `DeserializationConfig` | `with(SubtypeResolver str)` Method for constructing and returning a new instance with different `SubtypeResolver` to use.
    `DeserializationConfig` | `with(java.util.TimeZone tz)` Method for constructing and returning a new instance with different default `TimeZone` to use for formatting of date values.
    `DeserializationConfig` | `with(TypeFactory tf)` Method for constructing and returning a new instance with different `TypeFactory` to use.
    `DeserializationConfig` | `with(TypeResolverBuilder<?> trb)` Method for constructing and returning a new instance with different `TypeResolverBuilder` to use.
    `DeserializationConfig` | `with(VisibilityChecker<?> vc)` Method for constructing and returning a new instance with different `VisibilityChecker` to use.
    `DeserializationConfig` | `withAppendedAnnotationIntrospector(AnnotationIntrospector ai)` Method for constructing and returning a new instance with additional `AnnotationIntrospector` appended (as the lowest priority one)
    `DeserializationConfig` | `withFeatures(DeserializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `DeserializationConfig` | `withFeatures(com.fasterxml.jackson.core.FormatFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `DeserializationConfig` | `withFeatures(com.fasterxml.jackson.core.JsonParser.Feature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
    `DeserializationConfig` | `withHandler(DeserializationProblemHandler h)` Method that can be used to add a handler that can (try to) resolve non-fatal deserialization problems.
    `DeserializationConfig` | `withInsertedAnnotationIntrospector(AnnotationIntrospector ai)` Method for constructing and returning a new instance with additional `AnnotationIntrospector` inserted (as the highest priority one)
    `DeserializationConfig` | `withNoProblemHandlers()` Method for removing all configured problem handlers; usually done to replace existing handler(s) with different one(s)
    `DeserializationConfig` | `without(DeserializationFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
    `DeserializationConfig` | `without(DeserializationFeature first, DeserializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `DeserializationConfig` | `without(com.fasterxml.jackson.core.FormatFeature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
    `DeserializationConfig` | `without(com.fasterxml.jackson.core.JsonParser.Feature feature)` Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
    `DeserializationConfig` | `without(MapperFeature... features)` Method for constructing and returning a new instance with specified mapper features disabled.
    `DeserializationConfig` | `withoutFeatures(DeserializationFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `DeserializationConfig` | `withoutFeatures(com.fasterxml.jackson.core.FormatFeature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `DeserializationConfig` | `withoutFeatures(com.fasterxml.jackson.core.JsonParser.Feature... features)` Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
    `DeserializationConfig` | `withRootName(PropertyName rootName)` Method for constructing and returning a new instance with different root name to use (none, if null).
    `DeserializationConfig` | `withView(java.lang.Class<?> view)` Method for constructing and returning a new instance with different view to use.
    `DeserializationConfig` | `withVisibility(com.fasterxml.jackson.annotation.PropertyAccessor forMethod, com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility visibility)` Method for constructing and returning a new instance with different minimal visibility level for specified property type

    - ### Methods inherited from class com.fasterxml.jackson.databind.cfg.MapperConfigBase

      `copy, findConfigOverride, findMixInClassFor, findRootName, findRootName, getActiveView, getAttributes, getDefaultPropertyFormat, getDefaultPropertyIgnorals, getDefaultPropertyIgnorals, getDefaultVisibilityChecker, getFullRootName, getRootName, getSubtypeResolver, mixInCount, withAttribute, withAttributes, withoutAttribute, withRootName`

    - ### Methods inherited from class com.fasterxml.jackson.databind.cfg.MapperConfig

      `canOverrideAccessModifiers, collectFeatureDefaults, compileString, constructSpecializedType, constructType, constructType, getBase64Variant, getClassIntrospector, getDateFormat, getDefaultTyper, getHandlerInstantiator, getLocale, getPropertyNamingStrategy, getTimeZone, getTypeFactory, hasMapperFeatures, introspectClassAnnotations, introspectDirectClassAnnotations, isAnnotationProcessingEnabled, isEnabled, shouldSortPropertiesAlphabetically, typeIdResolverInstance, typeResolverBuilderInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _problemHandlers

          protected final LinkedNode<DeserializationProblemHandler> _problemHandlers

      Linked list that contains all registered problem handlers. Implementation as front-added linked list allows for sharing of the list (tail) without copying the list.

    - #### _nodeFactory

          protected final JsonNodeFactory _nodeFactory

      Factory used for constructing `JsonNode` instances.

    - #### _deserFeatures

          protected final int _deserFeatures

      Set of `DeserializationFeature`s enabled.

    - #### _parserFeatures

          protected final int _parserFeatures

      States of `JsonParser.Feature`s to enable/disable.

    - #### _parserFeaturesToChange

          protected final int _parserFeaturesToChange

      Bitflag of `JsonParser.Feature`s to enable/disable

    - #### _formatReadFeatures

          protected final int _formatReadFeatures

      States of `FormatFeature`s to enable/disable.
      Since:
        2.7

    - #### _formatReadFeaturesToChange

          protected final int _formatReadFeaturesToChange

      Bitflag of `FormatFeature`s to enable/disable
      Since:
        2.7

  - ### Constructor Detail

    - #### DeserializationConfig

          public DeserializationConfig(BaseSettings base,
                               SubtypeResolver str,
                               SimpleMixInResolver mixins,
                               RootNameLookup rootNames,
                               ConfigOverrides configOverrides)

      Constructor used by ObjectMapper to create default configuration object instance.

    - #### DeserializationConfig

          @Deprecated
          public DeserializationConfig(BaseSettings base,
                                          SubtypeResolver str,
                                          SimpleMixInResolver mixins,
                                          RootNameLookup rootNames)

      Deprecated. Since 2.8, remove from 2.9 or later

    - #### DeserializationConfig

          protected DeserializationConfig(DeserializationConfig src,
                               ContextAttributes attrs)

    - #### DeserializationConfig

          protected DeserializationConfig(DeserializationConfig src,
                               SimpleMixInResolver mixins)

    - #### DeserializationConfig

          protected DeserializationConfig(DeserializationConfig src,
                               SimpleMixInResolver mixins,
                               RootNameLookup rootNames,
                               ConfigOverrides configOverrides)

      Copy-constructor used for making a copy used by new `ObjectMapper`.
      Since:
        2.8

  - ### Method Detail

    - #### getBaseSettings

          protected BaseSettings getBaseSettings()

    - #### with

          public DeserializationConfig with(MapperFeature... features)

      Description copied from class: `MapperConfig`
      Method for constructing and returning a new instance with specified mapper features enabled.
      Specified by:
        `with` in class `MapperConfig<DeserializationConfig>`

    - #### without

          public DeserializationConfig without(MapperFeature... features)

      Description copied from class: `MapperConfig`
      Method for constructing and returning a new instance with specified mapper features disabled.
      Specified by:
        `without` in class `MapperConfig<DeserializationConfig>`

    - #### with

          public DeserializationConfig with(MapperFeature feature,
                                   boolean state)

      Specified by:
        `with` in class `MapperConfig<DeserializationConfig>`

    - #### with

          public DeserializationConfig with(ClassIntrospector ci)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `ClassIntrospector` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(AnnotationIntrospector ai)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `AnnotationIntrospector` to use (replacing old one).

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(VisibilityChecker<?> vc)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `VisibilityChecker` to use.
      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### withVisibility

          public DeserializationConfig withVisibility(com.fasterxml.jackson.annotation.PropertyAccessor forMethod,
                                             com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility visibility)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different minimal visibility level for specified property type
      Specified by:
        `withVisibility` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(TypeResolverBuilder<?> trb)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `TypeResolverBuilder` to use.
      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(SubtypeResolver str)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `SubtypeResolver` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(PropertyNamingStrategy pns)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `PropertyNamingStrategy` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### withRootName

          public DeserializationConfig withRootName(PropertyName rootName)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different root name to use (none, if null).

      Note that when a root name is set to a non-Empty String, this will automatically force use of root element wrapping with given name. If empty String passed, will disable root name wrapping; and if null used, will instead use `SerializationFeature` to determine if to use wrapping, and annotation (or default name) for actual root name to use.

      Specified by:
        `withRootName` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`
      Parameters:
        `rootName` - to use: if null, means "use default" (clear setting); if empty String ("") means that no root name wrapping is used; otherwise defines root name to use.

    - #### with

          public DeserializationConfig with(TypeFactory tf)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `TypeFactory` to use.
      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(java.text.DateFormat df)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `DateFormat` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(HandlerInstantiator hi)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different `HandlerInstantiator` to use.

      NOTE: make sure to register new instance with `ObjectMapper` if directly calling this method.

      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### withInsertedAnnotationIntrospector

          public DeserializationConfig withInsertedAnnotationIntrospector(AnnotationIntrospector ai)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with additional `AnnotationIntrospector` inserted (as the highest priority one)
      Specified by:
        `withInsertedAnnotationIntrospector` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### withAppendedAnnotationIntrospector

          public DeserializationConfig withAppendedAnnotationIntrospector(AnnotationIntrospector ai)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with additional `AnnotationIntrospector` appended (as the lowest priority one)
      Specified by:
        `withAppendedAnnotationIntrospector` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### withView

          public DeserializationConfig withView(java.lang.Class<?> view)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different view to use.
      Specified by:
        `withView` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(java.util.Locale l)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different default `Locale` to use for formatting.
      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(java.util.TimeZone tz)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different default `TimeZone` to use for formatting of date values.
      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(com.fasterxml.jackson.core.Base64Variant base64)

      Description copied from class: `MapperConfigBase`
      Method for constructing and returning a new instance with different default `Base64Variant` to use with base64-encoded binary values.
      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(ContextAttributes attrs)

      Description copied from class: `MapperConfigBase`
      Method for constructing an instance that has specified contextual attributes.
      Specified by:
        `with` in class `MapperConfigBase<DeserializationFeature,DeserializationConfig>`

    - #### with

          public DeserializationConfig with(DeserializationFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.

    - #### with

          public DeserializationConfig with(DeserializationFeature first,
                                   DeserializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.

    - #### withFeatures

          public DeserializationConfig withFeatures(DeserializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.

    - #### without

          public DeserializationConfig without(DeserializationFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.

    - #### without

          public DeserializationConfig without(DeserializationFeature first,
                                      DeserializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.

    - #### withoutFeatures

          public DeserializationConfig withoutFeatures(DeserializationFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.

    - #### with

          public DeserializationConfig with(com.fasterxml.jackson.core.JsonParser.Feature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
      Since:
        2.5

    - #### withFeatures

          public DeserializationConfig withFeatures(com.fasterxml.jackson.core.JsonParser.Feature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
      Since:
        2.5

    - #### without

          public DeserializationConfig without(com.fasterxml.jackson.core.JsonParser.Feature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
      Since:
        2.5

    - #### withoutFeatures

          public DeserializationConfig withoutFeatures(com.fasterxml.jackson.core.JsonParser.Feature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
      Since:
        2.5

    - #### with

          public DeserializationConfig with(com.fasterxml.jackson.core.FormatFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
      Since:
        2.7

    - #### withFeatures

          public DeserializationConfig withFeatures(com.fasterxml.jackson.core.FormatFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features enabled.
      Since:
        2.7

    - #### without

          public DeserializationConfig without(com.fasterxml.jackson.core.FormatFeature feature)

      Fluent factory method that will construct and return a new configuration object instance with specified feature disabled.
      Since:
        2.7

    - #### withoutFeatures

          public DeserializationConfig withoutFeatures(com.fasterxml.jackson.core.FormatFeature... features)

      Fluent factory method that will construct and return a new configuration object instance with specified features disabled.
      Since:
        2.7

    - #### with

          public DeserializationConfig with(JsonNodeFactory f)

      Fluent factory method that will construct a new instance with specified `JsonNodeFactory`

    - #### withHandler

          public DeserializationConfig withHandler(DeserializationProblemHandler h)

      Method that can be used to add a handler that can (try to) resolve non-fatal deserialization problems.

    - #### withNoProblemHandlers

          public DeserializationConfig withNoProblemHandlers()

      Method for removing all configured problem handlers; usually done to replace existing handler(s) with different one(s)

    - #### initialize

          public void initialize(com.fasterxml.jackson.core.JsonParser p)

      Method called by `ObjectMapper` and `ObjectReader` to modify those `JsonParser.Feature` settings that have been configured via this config instance.
      Since:
        2.5

    - #### getAnnotationIntrospector

          public AnnotationIntrospector getAnnotationIntrospector()

      Method for getting `AnnotationIntrospector` configured to introspect annotation values used for configuration.
      Overrides:
        `getAnnotationIntrospector` in class `MapperConfig<DeserializationConfig>`

    - #### introspectClassAnnotations

          public BeanDescription introspectClassAnnotations(JavaType type)

      Accessor for getting bean description that only contains class annotations: useful if no getter/setter/creator information is needed.
      Specified by:
        `introspectClassAnnotations` in class `MapperConfig<DeserializationConfig>`

    - #### introspectDirectClassAnnotations

          public BeanDescription introspectDirectClassAnnotations(JavaType type)

      Accessor for getting bean description that only contains immediate class annotations: ones from the class, and its direct mix-in, if any, but not from super types.
      Specified by:
        `introspectDirectClassAnnotations` in class `MapperConfig<DeserializationConfig>`

    - #### getDefaultPropertyInclusion

          public com.fasterxml.jackson.annotation.JsonInclude.Value getDefaultPropertyInclusion()

      Description copied from class: `MapperConfig`
      Accessor for default property inclusion to use for serialization, used unless overridden by per-type or per-property overrides.
      Specified by:
        `getDefaultPropertyInclusion` in class `MapperConfig<DeserializationConfig>`

    - #### getDefaultPropertyInclusion

          public com.fasterxml.jackson.annotation.JsonInclude.Value getDefaultPropertyInclusion(java.lang.Class<?> baseType)

      Description copied from class: `MapperConfig`
      Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type.
      NOTE: if no override found, defaults to value returned by `MapperConfig.getDefaultPropertyInclusion()`.
      Specified by:
        `getDefaultPropertyInclusion` in class `MapperConfig<DeserializationConfig>`

    - #### getDefaultPropertyInclusion

          public com.fasterxml.jackson.annotation.JsonInclude.Value getDefaultPropertyInclusion(java.lang.Class<?> baseType,
                                                                                       com.fasterxml.jackson.annotation.JsonInclude.Value defaultIncl)

      Description copied from class: `MapperConfig`
      Accessor for default property inclusion to use for serialization, considering possible per-type override for given base type; but if none found, returning given `defaultIncl`
      Specified by:
        `getDefaultPropertyInclusion` in class `MapperConfig<DeserializationConfig>`
        `defaultIncl` - Inclusion setting to return if no overrides found.

    - #### useRootWrapping

          public boolean useRootWrapping()

      Description copied from class: `MapperConfig`
      Accessor for checking whether configuration indicates that "root wrapping" (use of an extra property/name pair at root level) is expected or not.
      Specified by:
        `useRootWrapping` in class `MapperConfig<DeserializationConfig>`

    - #### isEnabled

          public final boolean isEnabled(DeserializationFeature f)

    - #### isEnabled

          public final boolean isEnabled(com.fasterxml.jackson.core.JsonParser.Feature f,
                          com.fasterxml.jackson.core.JsonFactory factory)

    - #### hasDeserializationFeatures

          public final boolean hasDeserializationFeatures(int featureMask)

      Bulk access method for checking that all features specified by mask are enabled.
      Since:
        2.3

    - #### hasSomeOfFeatures

          public final boolean hasSomeOfFeatures(int featureMask)

      Bulk access method for checking that at least one of features specified by mask is enabled.
      Since:
        2.6

    - #### getDeserializationFeatures

          public final int getDeserializationFeatures()

      Bulk access method for getting the bit mask of all `DeserializationFeature`s that are enabled.

    - #### getProblemHandlers

          public LinkedNode<DeserializationProblemHandler> getProblemHandlers()

      Method for getting head of the problem handler chain. May be null, if no handlers have been added.

    - #### getNodeFactory

          public final JsonNodeFactory getNodeFactory()

    - #### introspect

          public <T extends BeanDescription> T introspect(JavaType type)

      Method that will introspect full bean properties for the purpose of building a bean deserializer
      Parameters:
        `type` - Type of class to be introspected

    - #### introspectForCreation

          public <T extends BeanDescription> T introspectForCreation(JavaType type)

      Method that will introspect subset of bean properties needed to construct bean instance.

    - #### introspectForBuilder

          public <T extends BeanDescription> T introspectForBuilder(JavaType type)

      Since:
        2.0

    - #### findTypeDeserializer

          public TypeDeserializer findTypeDeserializer(JavaType baseType)
                                                throws JsonMappingException

      Helper method that is needed to properly handle polymorphic referenced types, such as types referenced by `AtomicReference`, or various "optional" types.
      Throws:
        `JsonMappingException`
      Since:
        2.4